package genColl08Iterator;

import java.util.*;

public class Zug <E> extends AbstractList<E>
{
	private Wagon<E> lok;
	
	public Zug(E o)
	{
		lok = new Wagon<E>(o);
	}
	
	// Muss vor Benutzung berschrieben werden
	// die geerbte Methode ist funktionslos
	// und wirft lediglich einen Fehler zurck 
	// Muss fr sortier-Funktion ergnzt werden!
	public E set(int wagonNummer, E o)
	{
		// Starte bei der Lok
		Wagon<E> w = lok;
		int wagonZaehler = 0;
						
		// Gehe die Wogons entlag bis zur angegebenen Wagonnummer
		// oder bis der letzte Wagon erreicht ist
		while (		w.getNext() != null			//es gibt noch einen nachfolger
					&&	wagonZaehler < wagonNummer)	// Wagonnummer wurde noch nicht erreicht
		{
			w = w.getNext();
			wagonZaehler = wagonZaehler+1;
		}
		
		// gib den Inhalt des erreichten Wagons zurck
		// Ersetzt den Inhalt durch das angegebene Objekt
		E speicher  = w.getInhalt();
		w.setInhalt(o);
		return speicher;
	}
	
	// Muss vor Benutzung berschrieben werden
	// die geerbte Methode ist funktionslos
	// und wirft lediglich einen Fehler zurck 
	public boolean add (E o)
	{
		// Starte bei der Lock
		Wagon<E> w = lok;
		
		// Gehe die Wogons entlag bis der letzte erreicht ist
		while (w.getNext() != null)
		{
			w = w.getNext();
		}
		
		// Erzeuge neuen Wagon
		Wagon<E> neu = new Wagon<E>(o);
		
		// Hnge neuen Wagon an den Letzten Wagon an
		w.setNext(neu);
		
		return true;
	}
	
	// Abstrakte Methode
	public int size()
	{
		int size = 1;
		
		// Starte bei der Lock
		Wagon<E> w = lok;
		
		// Gehe die Wogons entlag bis der letzte erreicht ist
		while (w.getNext() != null)
		{
			w = w.getNext();
			size = size + 1;
		}		
		return size;
	}
	
	// abstrakte Methode
	public E get (int wagonNummer)
	{
		// Starte bei der Lock
		Wagon<E> w = lok;
		int wagonZaehler = 0;
				
		// Gehe die Wogons entlag bis zur angegebenen Wagonnummer
		// oder bis der letzte Wagon erreicht ist
		while (		w.getNext() != null			//es gibt noch einen nachfolger
				&&	wagonZaehler < wagonNummer)	// Wagonnummer wurde noch nicht erreicht
		{
			w = w.getNext();
			wagonZaehler = wagonZaehler+1;
		}
		
		// gib den Inhalt des erreichten Wagons zurck
		return w.getInhalt();
	}
	
	public Iterator<E> iterator()
	{
		return new MyIterator<E>(this.lok);
	}
	
	
	private static class Wagon<T>
	{
	// Objektvariablen
		private Wagon<T> next;
		private T inhalt;
		
	// Konstruktoren
		public Wagon (T inhalt)
		{
			this.inhalt = inhalt;
			this.next = null;
		}
		
	// Objektmethoden
		public Wagon<T> getNext()
		{
			return this.next;
		}
		
		public void setNext(Wagon<T> w)
		{
			this.next = w;
		}
		
		public T getInhalt()
		{
			return this.inhalt;
		}
		
	// Muss fr sortier-Funktion ergnzt werden!
		public void setInhalt(T o)
		{
			this.inhalt = o;
		}
	}	
	
	private static class MyIterator <T> implements Iterator<T>
	{
		Wagon<T> cursor;
		
		public MyIterator(Wagon<T> lock)
		{
			// Cursor durch leeren Wagon vor der Lock positionieren
			cursor = new Wagon<T>(null);
			cursor.setNext(lock);
		}
		
		public boolean hasNext()
		{
			if (cursor.getNext() != null)	return true;
			else return false;
		}

		public T next()
		{
			cursor = cursor.getNext();
			return cursor.getInhalt();
		}

		public void remove()
		{
			cursor.setNext(cursor.getNext().getNext());		
		}
	}	
}
